//hi! im bandder! as an srb2 modder, learning lua was kinda hard as a beginner, and when i wanted to get into making maps, i didn't know how to make my own enemies!
//this here is my REUSABLE enemy base for all your enemy needs! this is a basic enemy almost identical to the crawla in the vanilla game, meant as a starting off point for newcomers!

freeslot("MT_BANDDERCRAWLA",
"SPR_BNCW",
"S_BANDDERCRAWLA_WALK1",
"S_BANDDERCRAWLA_WALK2",
"S_BANDDERCRAWLA_WALK3",
"S_BANDDERCRAWLA_WALK4",
"S_BANDDERCRAWLA_WALK5",
"S_BANDDERCRAWLA_WALK6",
"S_BANDDERCRAWLA_LOOK")

//we need to freeslot these into the game so that srb2 registers them as valid assets
//be sure to freeslot any new sprites/states/objects you add to the game!


//these are info of our freesloted assets

mobjinfo[MT_BANDDERCRAWLA] = {
	doomednum = 666,
	spawnstate = S_BANDDERCRAWLA_LOOK,
	spawnhealth = 1,
	seestate = S_BANDDERCRAWLA_WALK1,
	speed = 3,
	deathstate = S_XPLD_FLICKY,
	radius = 24*FRACUNIT,
	height = 32*FRACUNIT,
	mass = 100,
	damage = 0,
	deathsound = sfx_pop,
	mass = 100,
	flags = MF_SPECIAL|MF_SHOOTABLE|MF_ENEMY|MF_RUNSPAWNFUNC,
}

//important things:
//doomednum is the identifier of what object it is. this is used in zone builder and ultimate zone builder so that you can place them in your maps
//the states are what state the object switches to when they do the associated action
//radius and height are how big the object is
//object flags determine what type of object it is


states[S_BANDDERCRAWLA_LOOK] = {
	sprite = SPR_BNCW,
	frame = A,
	tics = 1,
	action = A_Look,
	var1 = 0,
	var2 = 0,
	nextstate = S_BANDDERCRAWLA_LOOK
}


states[S_BANDDERCRAWLA_WALK1] = {
	sprite = SPR_BNCW,
	frame = A,
	tics = 3,
	action = A_Chase,
	var1 = 0,
	var2 = 0,
	nextstate = S_BANDDERCRAWLA_WALK2
}
states[S_BANDDERCRAWLA_WALK2] = {
	sprite = SPR_BNCW,
	frame = B,
	tics = 3,
	action = A_Chase,
	var1 = 0,
	var2 = 0,
	nextstate = S_BANDDERCRAWLA_WALK3
}
states[S_BANDDERCRAWLA_WALK3] = {
	sprite = SPR_BNCW,
	frame = C,
	tics = 3,
	action = A_Chase,
	var1 = 0,
	var2 = 0,
	nextstate = S_BANDDERCRAWLA_WALK4
}
states[S_BANDDERCRAWLA_WALK4] = {
	sprite = SPR_BNCW,
	frame = D,
	tics = 3,
	action = A_Chase,
	var1 = 0,
	var2 = 0,
	nextstate = S_BANDDERCRAWLA_WALK5
}
states[S_BANDDERCRAWLA_WALK5] = {
	sprite = SPR_BNCW,
	frame = E,
	tics = 3,
	action = A_Chase,
	var1 = 0,
	var2 = 0,
	nextstate = S_BANDDERCRAWLA_WALK6
}
states[S_BANDDERCRAWLA_WALK6] = {
	sprite = SPR_BNCW,
	frame = F,
	tics = 3,
	action = A_Chase,
	var1 = 0,
	var2 = 0,
	nextstate = S_BANDDERCRAWLA_WALK1
}

//WOW! thats a lot of states! however, for the walking frames, each state is for 1 frame of animation. if you notice on S_BANDDERCRAWLA_WALK6, the next state is S_BANDDERCRAWLA_WALK1, making it loop

//general info on states you should know
//sprite is the sprites you use
//frame is the frame of the sprite it uses. adding the FF_ANIMATE flag allows it to animate within the state
//tics is how long the state lasts
//action is the action the state makes the object do. A_Chase makes the enemy chase the player
//var 1 and var 2 have misc uses, for this case, var 1 sets how many frames the animation goes through, and var 2 sets how fast the animation plays
//next state is the next state it goes to. 

//sprite naming is a four letter prefix followed by a letter and a  number. the letter being the frame, and the number being the rotation!
//normal rotation numbers are 1 through 8. 1 being the character facing forward, and 8 being facing diagonally forward right

//if you want to test them in-game, use the commands "devmode" and "objectplace" to place them in-game



//here are some useful links that have some nice stuff!
//if you need help with sprite naming multiple sprites, use this script to greatly reduce the workload! https://mb.srb2.org/addons/srb2-sprite-namer-lua-script-for-slade.4691/
//list of actions that can be used with lua: https://wiki.srb2.org/wiki/Actions#Actions_with_Lua
//if you need help with how sprite naming works, here is this page that details how it works! https://wiki.srb2.org/wiki/Sprite#Format
//crawla enemy used for refrence (the recreation for this base isn't 1 to 1): https://wiki.srb2.org/wiki/Crawla_(Blue)



//with that being said i hope that this is useful to you for future refrence!
//if anyone is asking for some kind of enemy base, or doesn't know where to start, show em this!
//if you have any questions, ask them in the discussion forum!


//-banddy (or bandder on the mb)


